<?php

$dbConnection = null;

//require_once('lib/adodb510/adodb-exceptions.inc.php');
//require_once('lib/adodb510/adodb.inc.php');

require_once( $CONTENTIGO_HOME . '/modules/Database/lib/adodb511/adodb-exceptions.inc.php');
require_once( $CONTENTIGO_HOME . '/modules/Database/lib/adodb511/adodb.inc.php');

class Database extends Module 
{

	function Database() {
	}

	function module_init() {

		global $site;
		global $dataCollector;

		//load database config from env data:
		if( isset( $dataCollector['environment']['database'] ) && !empty( $dataCollector['environment']['database']) ) {
			//require_once( $CONTENTIGO_HOME . '/modules/Database.php');
			
			$this->getDBConnection( 
				$dataCollector['environment']['database']['database_type'],
				$dataCollector['environment']['database']['host'],
				$dataCollector['environment']['database']['username'],
				$dataCollector['environment']['database']['password'],
				$dataCollector['environment']['database']['schema']
			);
			
		} else {
			//echo 'site DATABASE_ENABLED, but enviroment database connection details not found.';
		}
	
	}


	public function &getDAO( $daoName) {

		//global $dbConnection;

//		if( !$this->isCached( $daoName) ) {

			global $SITE_LOCATION;
			$daoSciptName = $SITE_LOCATION . '/daos/' . $daoName . '.php';
			
			//if( !file_exists( "model-daos/$daoName.php") ) {
			if( !file_exists( $daoSciptName) ) {
				//invalid DAO name. dont continue.
				//should probably through an exception or something...
				return null;				
			}
			
			global $CONTENTIGO_HOME;
			require_once( $CONTENTIGO_HOME . '/modules/Database/DAO.php');
			require_once( $daoSciptName);
			$newDao = new $daoName();
			//$newDao->setDBConnection( $dbConnection);
			//$newDao->setDAOFactory( $this);
			$this->daoMap[ $daoName] = &$newDao;
//		}

		return $this->daoMap[ $daoName];
	}

	public function isCached( $daoName) {
		if( isset( $this->daoMap[ $daoName])) {
			return true; 
		}
		return false;
	}


	public function getDBConnection( $dbType, $host, $username, $password, $schema) {

		//attempt to close the connection
		$this->closeConnection();

		global $dbConnection;

		try {
		
			//setup a database connection
			$dbConnection = NewADOConnection( $dbType);
			$dbConnection->Connect(	$host, $username, $password, $schema);
			
		} catch (Exception $e) {
			//echo( "CATCH");
			//var_dump($e); 
		}
			//adodb_backtrace($e->gettrace());

		//to this by default:
		$dbConnection->SetFetchMode( ADODB_FETCH_ASSOC);
	}	


	public static function &getConnection() {
		global $dbConnection;
		
		if( !$dbConnection->IsConnected() ) {
			//Logger::Log('connection gone: closing...');
			$dbConnection->close();
			//Logger::Log('connection gone: reconnecting...');
			//DAOFactory::getDatabaseConnection('database');
			return false; 
		}		
		return $dbConnection;
	}
	
	public static function closeConnection() {
		global $dbConnection;
		if( !empty( $dbConnection)) {
			$result = $dbConnection->Close();
		} else {
			//already closed - by PHP? or just empty
		}
	} 
	
	function __destruct() {
		//DAOFactory::closeConnection();
		$this->closeConnection();
	}
	
}
?>